bossbar set giant_hp players @a
execute at @a run execute as @e[type=giant,distance=..100] run execute store result bossbar giant_hp value run data get entity @s Health
execute at @a if entity @e[type=giant,distance=..100] run bossbar set giant_hp visible true
execute at @a if entity @e[type=giant,distance=100..] run bossbar set giant_hp visible false
execute at @a unless entity @e[type=giant,distance=..100] run bossbar set giant_hp visible false

execute if entity @e[type=minecraft:giant] run execute at @e[type=minecraft:giant,nbt={HurtTime:10s}] run playsound entity.zombie.hurt hostile @a[distance=..50] ~ ~ ~ 100 0.2
execute as @e[tag=brain] run function giant:giant_death
kill @e[tag=played]

execute if entity @e[type=minecraft:giant] run execute as @e[type=minecraft:giant] store result score @s HP run data get entity @s Health

execute if entity @e[type=minecraft:giant,tag=!ai] run execute as @e[type=minecraft:giant,tag=!ai] run execute at @e[type=minecraft:giant,tag=!ai] run function giant:giant

execute if score @e[type=giant,tag=ai,limit=1] damage_cooldown matches ..1 run scoreboard players set @e[type=giant] damage_cooldown 90
execute if entity @e[type=minecraft:giant] run execute at @e[type=minecraft:giant,scores={damage_cooldown=25}] run function giant:attacks/area_damage
execute if entity @e[type=minecraft:giant] run scoreboard players remove @e[type=giant] damage_cooldown 1

execute if entity @e[type=minecraft:giant] run execute if score @e[type=giant,limit=1] big_stomp matches 1100.. run scoreboard players reset @e[type=giant] big_stomp
execute if entity @e[type=minecraft:giant] run execute at @e[type=minecraft:giant,scores={big_stomp=25..125}] run function giant:attacks/big_stomp
execute if entity @e[type=minecraft:giant] run scoreboard players add @e[type=giant] big_stomp 1

execute if entity @e[type=minecraft:giant] run execute as @e[type=minecraft:giant] store result score @s HP run data get entity @s Health
execute if entity @e[type=minecraft:giant] run execute as @e[type=minecraft:giant] if score @s HP matches ..25 run effect give @s minecraft:resistance infinite 2 true
execute as @e[type=giant,tag=!finale] run execute if score @s HP matches ..25 run function giant:attacks/final

execute if score @e[type=giant,tag=ai,limit=1] ambient_cooldown matches 300.. run scoreboard players reset @e[type=giant] ambient_cooldown
scoreboard players add @e[type=minecraft:giant,tag=ai] ambient_cooldown 1
execute if entity @e[type=minecraft:giant,tag=ai] run execute at @e[type=minecraft:giant,scores={ambient_cooldown=1}] run playsound minecraft:entity.zombie.ambient master @a[distance=..50] ~ ~ ~ 100 0.2

execute as @e[type=minecraft:zombie,tag=!process,tag=!checked] run tag @s add progressing
execute as @e[type=minecraft:zombie,tag=!process,tag=progressing,predicate=giant:5,predicate=giant:height_check] run tag @s add process
execute as @e[distance=0..,type=minecraft:zombie,sort=random,tag=process,predicate=giant:height_check] if score @a[limit=1] giant_cooldown matches -1 run execute if predicate giant:5 run execute if entity @a[advancements={minecraft:story/cure_zombie_villager=true}] run execute at @s run execute unless entity @e[type=giant] run function giant:giant
execute as @e[type=minecraft:zombie,tag=progressing] run tag @s add checked
execute as @e[type=minecraft:zombie,tag=progressing, tag=checked] run tag @s remove progressing

execute if score @a[limit=1] giant_cooldown matches ..0 run scoreboard players reset @a giant_cooldown
execute as @a run scoreboard players remove @a giant_cooldown 1

execute at @e[tag=horseman] run effect give @e[type=minecraft:zombie_horse,distance=..3] minecraft:resistance 1 2 true

schedule function giant:tick 1t